#include <Wire.h>

int ledPin = 13; //Ledpin
int spd; // mapped speed
//int //val; // joyy == speed
//int //val2; // joyx == steering
int spdpin = 3; //pwm enable/speed pin
int rpin1 = 4; //right motor pin 1
int rpin2 = 2; //right motor pin 2
int lpin1 = 6; //left motor pin 1
int lpin2 = 7; //left motor pin 2

void setup(){
  pinMode(ledPin,OUTPUT);
  pinMode(spdpin, OUTPUT);
  pinMode(rpin1, OUTPUT);
  pinMode(rpin2, OUTPUT);
  pinMode(lpin1, OUTPUT);
  pinMode(lpin2, OUTPUT);
  nunchuck_init();
  delay(1000);
  digitalWrite(ledPin, HIGH);  
}





static uint8_t nunchuck_buf[6];   // array to store nunchuck data,



// initialize the I2C system, join the I2C bus,
// and tell the nunchuck we're talking to it
void nunchuck_init()
{ 
  Wire.begin();	                // join i2c bus as master
  Wire.beginTransmission(0x52);	// transmit to device 0x52
  Wire.send(0x40);		// sends memory address
  Wire.send(0x00);		// sends sent a zero.  
  Wire.endTransmission();	// stop transmitting
}

// Send a request for data to the nunchuck
// was "send_zero()"
void nunchuck_send_request()
{
  Wire.beginTransmission(0x52);	// transmit to device 0x52
  Wire.send(0x00);		// sends one byte
  Wire.endTransmission();	// stop transmitting
}

// Receive data back from the nunchuck, 
int nunchuck_get_data()
{
    int cnt=0;
    Wire.requestFrom (0x52, 6);	// request data from nunchuck
    while (Wire.available ()) {
      // receive byte as an integer
      nunchuck_buf[cnt] = nunchuk_decode_byte(Wire.receive());
      cnt++;
    }
    nunchuck_send_request();  // send request for next data payload
    // If we recieved the 6 bytes, then go print them
    if (cnt >= 5) {
     return 1;   // success
    }
    return 0; //failure
    
}

///
///  MY CODE
///
/// 174 is the center for both the x and y axes of the joystick

void gomotors(int val, int val2) // motor function taking in 2 values from nunchuck
{ 
// speed
if (val == 174){spd = 0;} //joyy
  else{if (val > 174){ // if the joystick is up
     spd = map(val, 174, 255, 0, 255); // map the value from up min to up max for pwm
       forward();} // set motor config forward
     else{if (val < 174){ // if the joystick is down
     spd = map(val, 46, 174, 255, 0); // map the value from min to max ( min = 255, max = 0)
       backward();} // set motor config backwards
     else{}
   }
  }
  //end speed
  //steering
  if (val2 > 165 & val2 < 185){}// dead zone
  else{if (val2 > 174){  // if the joystick is right
       spd = map(val2, 174, 255, 0, 255); // map the speed according to how far right the joystick is
       right();}// make motors turn the vehicle right
     else{if (val2 < 174){   //if the joystick is left
       spd = map(val2, 46, 174, 255, 0); // map the speed according to how far left the joystick is
       left();} // make motors turn the vehicle left
         else{}
   }
  }
 //end steering 
 analogWrite(spdpin, spd); // turn motors to speed
    
}

// Encode data to format that most wiimote drivers except
// only needed if you use one of the regular wiimote drivers
char nunchuk_decode_byte (char x)
{
  x = (x ^ 0x17) + 0x17;
  return x;
}

void forward(){ // l293d forward
digitalWrite(rpin1, LOW);
digitalWrite(rpin2, HIGH);  
digitalWrite(lpin1, LOW);
digitalWrite(lpin2, HIGH);
}

void backward(){ // l293d reverse
digitalWrite(rpin2, LOW);
digitalWrite(rpin1, HIGH);  
digitalWrite(lpin2, LOW);
digitalWrite(lpin1, HIGH);
}

void right(){ // l293d right
digitalWrite(rpin1, HIGH);
digitalWrite(rpin2, LOW);  
digitalWrite(lpin1, LOW);
digitalWrite(lpin2, HIGH);
}

void left(){ // l293d left
digitalWrite(rpin2, HIGH);
digitalWrite(rpin1, LOW);  
digitalWrite(lpin2, LOW);
digitalWrite(lpin1, HIGH);
}

void loop(){
 nunchuck_get_data(); //get nunchuck's data
 gomotors(nunchuck_buf[1],nunchuck_buf[0]); // set pins + speed
 delay(60);
}

